#include <iostream>
using namespace std;

struct cd {
	char titolo[20];
	char genere[20];
	char cantante[20];
	float durata;
	int anno;
	char canc;
};

bool compareString(char a[], char b[]){
	bool equal = true;
	for(int i = 0; (a[i] != '\0') && (b[i] != '\0') && equal; i++)
		if(a[i] != b[i]) equal = false;
	return equal;
}

int ricerca_cd(cd ve[], int dim, char titolo[]){
	bool f = true;
	int i, j;

	for(i = 0; (i < dim) && f; i++)
		if(ve[i].canc == 'a')
			f = !compareString(ve[i].titolo, titolo);
	if(f) return -1;
	return i - 1;
}

void stampa_cd(cd ve[], int i){
	if(ve[i].canc == 'a') {
		cout << "\nTitolo: " << ve[i].titolo;
		cout << "\nGenere: " << ve[i].genere;
		cout << "\nCantante: " << ve[i].cantante;
		cout << "\nDurata: " << ve[i].durata;
		cout << "\nAnno: " << ve[i].anno;
		cout << "\n\n";
	}
}

void elenco_cd(cd ve[], int dim){
	for(int i = 0; i < dim; i++) stampa_cd(ve, i);
}

bool aggiunta(cd ve[], int dim){
	bool b = true;
	for(int i = 0; (i < dim) && b; i++)
		if(ve[i].canc == 'c') {
			cout << "\nInserisci il titolo: ";
			cin >> ve[i].titolo;
			cout << "\nInserisci il genere: ";
			cin >> ve[i].genere;
			cout << "\nInserisci il cantante: ";
			cin >> ve[i].cantante;
			cout << "\nInserisci la durata: ";
			cin >> ve[i].durata;
			cout << "\nInserisci l'anno: ";
			cin >> ve[i].anno;

			ve[i].canc = 'a';
			b = false;
		}
	return !b;
}

bool eliminazione(cd ve[], int dim, char titolo[]){
	int i = ricerca_cd(ve, dim, titolo);
	if(i >= 0) ve[i].canc = 'c';
	//cout << i << " " << ve[i].canc;
	return i >= 0;
}

void cd_cantante(cd ve[], int dim, char cantante[]){
	int i, j;
	for(i = 0; i < dim; i++){
		if((ve[i].canc == 'a') && compareString(ve[i].cantante, cantante)) stampa_cd(ve, i);
	}
}

bool ricerca(cd ve[], int i){
	bool b = true;
	int start = i;
	while((i-- > 0) && b){
		//cout << i << " " << ve[i].canc << " " << ve[i].genere << " " << start << " " << ve[start].genere << endl;
		if((ve[i].canc == 'a') && compareString(ve[i].genere, ve[start].genere)) b = false;
	}
	return !b;
}

void raggruppa_genere(cd ve[], int dim){
	int j;
	for(int i = 0; i < dim; i++){
		if((ve[i].canc == 'a') && (!ricerca(ve, i))) {
			cout << "\nCd per il genere: " << ve[i].genere;
			for(j = i; j < dim; j++)
				if(compareString(ve[i].genere, ve[j].genere)) stampa_cd(ve, j);
		}
	}
}

int main(){
	int dim = 255, scelta;
	bool b = true;
	char input[20];
	cd ve[dim];
	for(int i = 0; i < dim; i++)
		ve[i].canc = 'c';

	while(b){
		cout << "\n[0] Aggiungi";
		cout << "\n[1] Rimuovi";
		cout << "\n[2] Elenco";
		cout << "\n[3] Elenco da un cantante";
		cout << "\n[4] Elenco per genere";
		cout << "\n[5] Ricerca di un cd";
		cout << "\n[6] Uscita";
		cout << "\n\n#";
		cin >> scelta;

		switch(scelta){
			case 0: {
				if(aggiunta(ve, dim))
					cout << "Disco aggiunto con successo!\n";
				else
					cout << "Si è verificato un errore :c\n";
				break;
			}
			case 1: {
				cout << "Inserisci il titolo del disco da eliminare: ";
				cin >> input;
				if(eliminazione(ve, dim, input))
					cout << "Disco eliminato con successo!\n";
				else
					cout << "Non è stato possibile eliminare il disco :c\n";
				break;
			}
			case 2: {
				cout << "\nElenco dei cd:\n";
				elenco_cd(ve, dim);
				break;
			}
			case 3: {
				cout << "Inserisci il nome del cantante: ";
				cin >> input;
				cd_cantante(ve, dim, input);
				break;
			}
			case 4: {
				cout << "\nElenco in base ai generi:\n";
				raggruppa_genere(ve, dim);
				break;
			}
			case 5: {
				cout << "\nInserisci il titolo del disco: ";
				cin >> input;
				stampa_cd(ve, ricerca_cd(ve, dim, input));
				break;
			}
			case 6: {
				b = false;
				break;
			}
			default: cout << "\nScelta non valida\n";
		}
	}
}
